/* for high performance SYNC */
/*
#undef THREAD_STOLEN_HOOK()
#  define THREAD_STOLEN_HOOK() __waiter_stolen__ = 1
#  define USE_SYNCHED volatile int __waiter_stolen__ = 0
#  define SYNCHED !__waiter_stolen__
*/

/* include files for parallel Sthreads */
#  include <cilkcnt.h>
#  include <smllc.h>
/* commonly used macros */
#  define cilk
typedef long Cilk_time;
#  define Cilk_get_wall_time() st_current_time_ms()
#  define Cilk_get_time() st_current_time_ms() /* used by cilksort */
#  define Cilk_wall_time_to_sec(e) (((e)+0.0)/1000.0)
#  define Cilk_time_to_sec(e) (((e)+0.0)/1000.0)

/* Perhaps not implemented in STHREADS */
#  define Cilk_user_work 0          /* Current number of generated works */
#  define Cilk_user_critical_path 0 /* Current number of critical paths  */

/* extra arg to pass a pointer of the variable which hold return value,
   and to pass a pointer of sync counter */
#  define CILK_PROC_ARGS(type)
#  define CILK_PROC_ARGS0(type)
#  define CILK_VOID_PROC_ARGS
#  define CILK_VOID_PROC_ARGS0
#  define CILK_INLET_PROC_ARGS(type)

/* spawns */
#  define USE_SPAWN
#  define USE_SPAWN_IF_CILK

/* sync */
#  define SYNC_IF_CILK
#  define LAST_SYNC_IF_CILK
#  define SYNC
#  define LAST_SYNC

/* return */
#  define RETURN(x) return(x)
#  define ATOMIC_ADD_RETURN(x)
#  define VOID_RETURN return

/* main wrappers */
#  define MAIN st_main
#  define cilk_main st_main

/* other primitives */
#  undef alloca  
#  define CILK_ASSERT st_assert       
#  ifdef USE_SMALLOC
#    define Cilk_malloc smalloc
#    define Cilk_free sfree
#    define Cilk_alloca smalloc_internal
#    define alloca smalloc_internal
#    define alloca_exp_free(a,b) sfree_internal(a)
#    define Cilk_internal_malloc smalloc_internal
#    define Cilk_internal_free(a,b) sfree_internal(a)
#    define Cilk_internal_malloc_fast smalloc_internal
#    define Cilk_internal_free_fast(a,b) sfree_internal(a)
#  else
#    ifdef WITH_SGC
#      define Cilk_malloc GC_malloc
#      define Cilk_free GC_free
#      define Cilk_internal_malloc GC_malloc
#      define Cilk_internal_free GC_free
#      define Cilk_internal_malloc_fast GC_malloc
#      define Cilk_internal_free_fast GC_free
#      define Cilk_alloca GC_malloc
#      define alloca GC_malloc
#      define alloca_exp_free(a, b) GC_free(a)
#    else /* WITH_SGC */
#      define Cilk_malloc st_malloc
#      define Cilk_free st_free
#      define Cilk_internal_malloc st_malloc
#      define Cilk_internal_free st_free
#      define Cilk_internal_malloc_fast st_malloc
#      define Cilk_internal_free_fast st_free
#      define Cilk_alloca st_malloc
#      define alloca st_malloc
#      define alloca_exp_free(a, b) st_free(a)
#    endif /* WITH_SGC */
#  endif  
#  define Cilk_active_size tls(gopts)->n_workers
#  define Cilk_die(a) do { fprintf(stderr,a); st_wg_die((void*)(-1)); } while(0)
#  define Cilk_lockvar long volatile
#  define Cilk_lock spin_lock
#  define Cilk_unlock(a) do{ MEMBAR_WRITE_WRITE();*(a)=0; }while(0)
#  define Cilk_lock_init(a) *(a)=0;

#  define shared 
#  define private 

#ifdef sparc
#  define CACHE_LINE 64
#elif defined(mips)
#  define CACHE_LINE 128
#endif

/* padding, to be used in structures to avoid false sharing */
#define CACHE_LINE_ALIGNED(decl) decl
#define Self tls(thread_id)
