#include <stdlib.h>
#include <stdio.h>

int fib(int n)
{
     if (n < 2)
	  return (n);
     else {
	  int x, y;
	  x = fib(n - 1);
	  y = fib(n - 2);
	  return (x + y);
     }
}

int fib_iter(int n)
{
     int f0, f1, f2, i;
     if (n < 2)
	  return n;
     f0 = 0;
     f1 = 1;
     f2 = 1;
     for (i = 2; i <= n; ++i) {
	  f2 = f0 + f1;
	  f0 = f1;
	  f1 = f2;
     }

     return f2;
}

int main(int argc, char *argv[])
{
     int n, answer;

     if (argc < 2) {
	  fprintf(stderr, "Usage: fib n\n");
	  return -1;
     }
     n = atoi(argv[1]);
     answer = fib(n);
     printf("fib(%d) = %d on %d processor%s\n",
	    n, answer, 1, 1 > 1 ? "s" : "");
     if (answer != fib_iter(n))
	  printf("WRONG ANSWER!\n");

     return 0;
}
