########################################################################
# C_CONFIG_FLAGS:
# Macro definitions for GC library.
########################################################################

C_CONFIG_FLAGS=-DOPERATOR_NEW_ARRAY -DATOMIC_UNCOLLECTABLE
# -DALL_INTERIOR_POINTERS -DFIND_LEAK -DSILENT

########################################################################
# CC, CXX, AS, AR:
# Specify compilers, assembler, archiver.
########################################################################

#CC = cc
CC = gcc
#CXX = CC
CXX = g++
AS=as
AR=ar

########################################################################
# SGC_OBJECT_64BIT:
# Set YES if you want to build 64bit version,
# otherwise(32bit version) NO.
########################################################################

#SGC_OBJECT_64BIT=YES
SGC_OBJECT_64BIT=NO

########################################################################
# SGC_THREAD_PKG:
# specify thread package.
#
# SGC_SOLARIS_THREAD_PTHREAD is a convinient choice on Solaris,
# because both Solaris thread and pthreads can be used.
# But I am uncertain whether this works on future Solaris version...
########################################################################

#SGC_THREAD_PKG=SGC_PTHREAD
#SGC_THREAD_PKG=SGC_SOLARIS_THREAD
#SGC_THREAD_PKG=SGC_SPROC_THREAD
#SGC_THREAD_PKG=SGC_FORK_THREAD
#SGC_THREAD_PKG=SGC_SOLARIS_THREAD_PTHREAD

########################################################################
# SGC_TLS_METHOD:
# Specify how GC library functions obtain thread local storage.
# See gc_tls.h for details.
# For thread version(SGC_THREAD_PKG is NOT SGC_FORK_THREAD), you can select
#   SGC_TLS_IMPORT_PUBLIC_FUNCTION
#   SGC_TLS_IMPORT_EACH_FUNCTION
#   SGC_TLS_REGISTER_VARIABLE (fastest, but GCC only)
# For process version(SGC_THREAD_PKG is SGC_FORK_THREAD), you must select
#   SGC_TLS_GLOBAL_VARIABLE
#
# If SGC_WITH_STHREADS is YES, this setting is ignored.
########################################################################

#SGC_TLS_METHOD=SGC_TLS_IMPORT_EACH_FUNCTION
#SGC_TLS_METHOD=SGC_TLS_IMPORT_PUBLIC_FUNCTION
SGC_TLS_METHOD=SGC_TLS_REGISTER_VARIABLE
#SGC_TLS_METHOD=SGC_TLS_GLOBAL_VARIABLE

########################################################################
# SGC_WITH_STHREADS:
# Set YES if you use StackThreads. otherwise NO.
########################################################################

SGC_WITH_STHREADS=YES
#SGC_WITH_STHREADS=NO


# for future release
# SGC_SHARE_HEAP_METHOD=SGC_HEAP_IMPLICITLY_SHARED
# SGC_SHARE_HEAP_METHOD=SGC_HEAP_MMAP_SHARED

