/*
 * Copyright (c) 1998-1999 by Toshio Endo. All rights reserved.
 *
 * THIS MATERIAL IS PROVIDED AS IS, WITH ABSOLUTELY NO WARRANTY EXPRESSED
 * OR IMPLIED.  ANY USE IS AT YOUR OWN RISK.
 *
 * Permission is hereby granted to use or copy this program
 * for any purpose,  provided the above notices are retained on all copies.
 * Permission to modify the code and to distribute modified code is granted,
 * provided the above notices are retained, and a notice that the code was
 * modified is included with the above copyright notice.
 *
 */

#ifdef MIPS

#include <sys/hwperfmacros.h>

typedef struct PERFC_handler {
    int gen;
    int fd;
    int e0;
    int e1;
} PERFC_handler_t;

typedef unsigned long long int PERFC_counter_t;

#elif defined SPARC

#include "picio.h"

typedef struct PERFC_handler {
    int fd;
    int e0;
    int e1;
} PERFC_handler_t;

typedef unsigned long int PERFC_counter_t;

#else

/* not supported architecture */

typedef struct {
    int dummy;
} PERFC_handler_t;

typedef unsigned long int PERFC_counter_t;

#endif

int PERFC_open(PERFC_handler_t *hp, int e0, int e1);
int PERFC_read(PERFC_handler_t *hp,
	       PERFC_counter_t *pc0, PERFC_counter_t *pc1);
int PERFC_close(PERFC_handler_t *hp);

